/* ********************************************************************************************************
*	  : Systart.c
*	    : ccx
*	    :  2020-11-10
*	    ־:
    
********************************************************************************************************* */
#include "sys_start.h"
#include "usb_desc.h"
#include "sys_tick.h"
#include "debug.h"

//
EEPROM_UNION E2promData;
REPORTX_UNION Reportx; //dfu
//Ʒ
PRODUCT_STRUCT g_pdf_data;
 
//
DEVICE_STRUCT g_dev;


//ⲿ
extern uint8 MIDI_DeviceDescriptor[MIDI_SIZ_DEVICE_DESC];    //豸
extern uint8 MIDI_StringSerial[MIDI_SIZ_STRING_SERIAL];      //кַ

/*
*********************************************************************************************************
*	  : systrat_flashDataInit
*	˵: flashȡ.
*	    :  
*	  ֵ:
*********************************************************************************************************
*/
void systrat_flashDataInit(void)
{
	uint8 *ei_addr,ei_tp1b1;
	uint32 ei_i;

	//ȡ
	ei_addr = (uint8 *)EEPROM_FACTSET_ADDR;
	for(ei_i=0;ei_i<EEPROM_DATA_SIZE;ei_i++)
	{
		E2promData.Buffer[ei_i] = *ei_addr++;
	}
		
	E2promData.Struct.Flag =DFU_MODE_APP;


	//E2promData.Struct.AppVersion = SOFTWARE_VER;
	//Dfu Version	
	MIDI_DeviceDescriptor[12] = E2promData.Struct.AppVersion&0xff;
	MIDI_DeviceDescriptor[13] = E2promData.Struct.AppVersion>>8;		 
		
	//Serial Number 
	for(ei_tp1b1=2,ei_i=0;ei_i<14;ei_i++,ei_tp1b1+=2)
	{
		//-chengxin modified -21/05/06  start
	   if(E2promData.Struct.SerialNumber[ei_i] == 0xFF || E2promData.Struct.SerialNumber[ei_i] < 30) MIDI_StringSerial[ei_tp1b1] = 'F'; //SN С30
		 else                                          MIDI_StringSerial[ei_tp1b1] = E2promData.Struct.SerialNumber[ei_i + 12]; 
		 MIDI_StringSerial[ei_tp1b1+1] = 0;
		//-chengxin modified -21/05/06  end
	}
	
	//Report Struct Init 
	Reportx.Struct.ReportID   = 0x60;
	Reportx.Struct.FunctionID = DFU_REPORT_MODE;
	Reportx.Struct.State      = DFU_STATE_DONE;
	Reportx.Struct.DLenLSB    = 0x40; 
	Reportx.Struct.DLenMSB    = 0x00; 
	Reportx.Struct.Mode       = DFU_MODE_APP;
	Reportx.Struct.DfuVersion = E2promData.Struct.DfuVersion;
	Reportx.Struct.AppVersion = E2promData.Struct.AppVersion;
	Reportx.Struct.Page       = 0x00; 
	Reportx.Struct.PageSum    = 0x00; 
	Reportx.Struct.CheckSsum  = 0x00;
    for(uint16 di_i=0;di_i<sizeof(Reportx.Struct.Reserve);di_i++)
	{
		Reportx.Struct.Reserve[di_i] = 0x0A;
	}			
	Reportx.Struct.Crc        = 0x00; 
	for(uint16 di_i=0;di_i<REPORT6X_SIZE;di_i++)
	{
		Reportx.Struct.Crc += Reportx.Buffer[di_i];
	}	
		
//	//ȡƷ
//	bsp_ReadCpuFlash(EEPROM_PRODUCT_ADDR,(uint8*)&g_pdf_data,sizeof(PRODUCT_STRUCT));
//
//	uint32 calc_crc = algo_calculate_crc8((uint8*)&g_pdf_data,sizeof(PRODUCT_STRUCT) - 4);
	
//	if(g_pdf_data.calibraValue[0] >0x40 || g_pdf_data.calibraValue[0] <0x10)g_pdf_data.calibraValue[0] = 0x20;
//	if(calc_crc  !=  g_pdf_data .crc ){//У
//		//		Ĭϲ
//		_PRINTF("crc error\r\n");
//	}
 
}
/*
*********************************************************************************************************
*	  : systrat_flashDataSave
*	˵: flashȡ.
*	    :  
*	  ֵ:
*********************************************************************************************************
*/
void systrat_flashDataSave(void)
{
//	g_pdf_data .crc = algo_calculate_crc8((uint8*)&g_pdf_data,sizeof(PRODUCT_STRUCT) - 4);
//	bsp_WriteCpuFlash(EEPROM_PRODUCT_ADDR,(uint8*)&g_pdf_data,sizeof(PRODUCT_STRUCT));
//	uint8  res = bsp_WriteCpuFlash(EEPROM_FACTSET_ADDR,(uint8*)&E2promData,sizeof(EEPROM_UNION));
//	if(res){
//		_PRINTF("write fail\r\n");
//	}
		
}

/*
*********************************************************************************************************
*	  : systrat_Init
*	˵: Ʒز.
*	    :  
*	  ֵ:
*********************************************************************************************************
*/
void systrat_Init(void)
{	
	systrat_flashDataInit();

}
/*
*********************************************************************************************************
*	  : Ϣ
*	˵: Ʒز.
*	    :  
*	  ֵ:
*********************************************************************************************************
*/

 void systart_upg_task(void)
{
	if(g_dev.sys_timeDfu == 1)
	{		
		//Read Save Data:
		E2promData.Struct.Flag = DFU_MODE_USER ;
		systrat_flashDataSave();
		//Reset Device:
		_PRINTF("jump boot\r\n");
		systick_delay_ms(10);
		//USB_Cable_Config(DISABLE);
		__disable_irq();
		while(1){};//ÿŹλ
		NVIC_SystemReset();			
	}	
}

