/* ********************************************************************************************************
*	  : Systart.h
*	    : ccx
*	    :  2020-11-10
*	    ־:

********************************************************************************************************* */
#ifndef _SYS_START_H
#define _SYS_START_H

#include "fifo.h"

#define MCU_SLEEP_TIME  1800000UL    //20*60*1000 30min޲
#define LED_CLOSE_TIME  1800000UL    //20*60*1000 30min



#define DRUM_PAD_NUM  7 //
#define STRUM_NUM  7  //
#define TOUCHBT_NUM  7 //




typedef enum {
	Ble_InitFail = 0,
	Ble_InitOk,
	Ble_WaitCon,
	Ble_ConOK,
}Ble_State;


//*   壺
#define EEPROM_PRODUCT_ADDR       0x0800F000  //Ʒݵַ
#define EEPROM_FACTSET_ADDR       0x0800FC00 //ݵַ

#define EEPROM_PAGE_LEN           1024

#define EEPROM_CHIP1_PAGE_SUM      384   //Zhixin 200812 Change;
#define EEPROM_CHIP2_PAGE_SUM      16

#define EEPROM_CMD_EREASE          0x01
#define EEPROM_CMD_WRITE           0x02
#define EEPROM_CMD_EW              0x03



//*   壺
#define CRC_BYTE1   0x20
#define CRC_BYTE2   0x04
#define CRC_BYTE3   0x02
#define CRC_BYTE4   0x12
#define CRC_SUM     ((CRC_BYTE1+CRC_BYTE2+CRC_BYTE3+CRC_BYTE4)&0x0F)

//Function
#define DFU_REPORT_MODE  0x01
#define DFU_REPORT_RES   0x02
#define DFU_REPORT_WRITE 0x03
#define DFU_REPORT_CRC   0x04
#define DFU_REPORT_CS    0x05
#define DFU_REPORT_REPLY 0x81

//State
#define DFU_STATE_IDLE   0x00
#define DFU_STATE_BUSY   0x01
#define DFU_STATE_DONE   0x02
#define DFU_STATE_ERROR  0x03
#define DFU_STATE_SEL    0x0F

//Mode
#define DFU_MODE_DFU     0x00
#define DFU_MODE_APP     0x01
#define DFU_MODE_USER    0x02
#define DFU_MODE_TEST    0x03

//boot  APP 
typedef struct
{ 
	 uint8   Flag;            //byte 0;
	 uint8  Reserve;         //byte 1;
	 uint16  Vid;             //byte 2-3;
	 uint16  DfuPid;          //byte 4-5;
	 uint16  AppPid;          //byte 6-7;
	 uint16  DfuVersion;      //byte 8-9;
	 uint16  AppVersion;      //byte 10-11;
	 uint8   SerialNumber[32]; //byte 12-43;
	 uint16  CheckSum1;       //byte 44-45;
	 uint16  CheckSum2;       //byte 46-47;

}EEPROM_STRUCT;

#define EEPROM_DATA_SIZE  47U

typedef union
{
	 EEPROM_STRUCT Struct;
	 uint8 Buffer[EEPROM_DATA_SIZE];
}EEPROM_UNION;

//Offset Address
#define EEPROM_FLAG_OFFSET        0



//ȫֱ
typedef struct {
	uint8 sys_timeRun;
	uint8 sys_timeRun2;
	uint8 sys_timeRun1;
	uint8 sys_timeRun3;
	uint8 sys_timeRun4;
	uint16 sys_timeUpBat;
	uint16 sys_timeRunVoic;//ť ʱ
	uint16 sys_timeSturmDelay[7];//ɨʱ
	uint16 sys_timeSturmSwitch;  //Ҽʱ

	uint16 sys_timeSturmAlarm;  //͵˸ʱ



	uint16 sys_timeDfu;
	uint32 sys_timeSleep;
	uint32 sys_timeLpower;

	volatile uint8 adcConvFlag ;//adcת
	volatile uint8 updateflag ;//и
	volatile uint16 curr_batVol;
	Ble_State ble_sta;


	uint8 curr_playMode;
	uint8 curr_musical;
	uint8 curr_octa;
	uint8 curr_voic;
	uint8 curr_chord;
	//BAT
	uint8 LowPowerTime;
	uint8 is_usb_power;
	uint8 curr_bat;
	//oled
	uint8 OledUpdateFlag;

}DEVICE_STRUCT;



//APP ר
typedef struct
{
	uint32 byte;
	uint8 calibraValue[4] ;
	uint8 blue_mac[12];
	uint32 crc;
}PRODUCT_STRUCT;

typedef struct
{
	 //Report Star:0~62
__attribute__((aligned(4))) //added by _paul 20210113
	 uint8  ReportID;        //byte 0;
	 uint8  FunctionID;      //byte 1;
	 uint8  State;           //byte 2;
	 uint8  DLenLSB;         //byte 3-4;
	 uint8  DLenMSB;
	 uint8  Mode;            //byte 5;
	 uint16 DfuVersion;      //byte 6-7;
	 uint16 AppVersion;      //byte 8-9;
   uint16 Page;            //byte 10-11;
   uint16 PageSum;         //byte 12-13;
	 uint16 CheckSsum;       //byte 14-15;
	 uint8  Reserve[47];     //byte 16-62;
	 uint8  Crc;             //byte 63;
	 uint8  FlashData[1024]; //byte 64-1087;
#pragma pack()
}REPORTX_STRUCT;

#define REPORT6X_SIZE  64U
#define REPORT7X_SIZE  1088U

typedef union
{
	 REPORTX_STRUCT Struct;
	 uint8 Buffer[REPORT7X_SIZE];

}REPORTX_UNION;

//⺯
void systart_bootloader_update(void);
void systrat_Init(void);
void systrat_flashDataSave(void);
 void systart_upg_task(void);
#endif





