
/* ********************************************************************************************************
*	  : usb.h
*	    : ccx
*	    :  2020-11-10
*	    ־:

********************************************************************************************************* */
#ifndef _USB_H_
#define _USB_H_

#include "ch32v30x_usbhs_host.h"
#include "ch32v30x_usbotg_device.h"
#include "fifo.h"

#define USB_RX_BUF_SIZE             512  //

extern DATA_FIFO midi_UsbRxFifo;
extern DATA_FIFO midi_UsbTxFifo;
extern DATA_FIFO hid_UsbRxFifo;
extern DATA_FIFO hid_UsbTxFifo;


#define USBmidi_recvRemainNum()  fifo_get_currNum(&midi_UsbRxFifo)
#define USBmidi_sendRemainNum()  fifo_get_currNum(&midi_UsbTxFifo)
#define USBhid_recvRemainNum()  fifo_get_currNum(&hid_UsbRxFifo)
#define USBhid_sendRemainNum()  fifo_get_currNum(&hid_UsbTxFifo)

typedef enum{
	USB_MIDI =0,
	USB_HID,	
}USB_DEV;


//midi
u32 usb_midiRead(u8* buffter, u32 buffterSize);
//hid
u32 usb_hidRead(u8* buffter, u32 buffterSize);
//дmidi
u32 usb_midiWrite(u8* buffter, u32 buffterSize);
//дhid
u32 usb_hidWrite(u8* buffter, u32 buffterSize);
void usb_init(void);
void usb_txTask(void);
void usbHost_task(void);
#endif




